<script lang="ts" setup>
/**
 * i18n note: Content using this component must contain IDs throughout every level and cannot use a fallback value.
 * More info found here: https://gitlab.com/gitlab-com/marketing/digital-experience/about-gitlab-com/-/merge_requests/350#note_2340731315
 **/

import { ref, computed, watch, onMounted, onUpdated } from 'vue';
import { useRoute } from 'vue-router';
import { Anchor, ChevronLgRight } from 'slippers-ui/icons';
import { useI18n } from 'vue-i18n';
const { t } = useI18n();

interface FaqGroup {
  header: string;
  questions: Array<{
    question: string;
    answer: string;
    config: {
      expanded?: boolean;
      id: string;
    };
  }>;
  config: {
    id: string;
    dataToggle?: string;
  };
}

interface Props {
  header: string;
  groups: Array<FaqGroup>;
  activeHeader?: string; // If you want this to dynamically change (ex: Pricing page FAQ), that logic is handled in a parent component and the changing value is passed down as a prop
  config: {
    id: string;
    backgroundColor?: string;
    normalHeader?: boolean;
    hasJumpDown?: boolean;
    showToggle?: boolean;
  };
}

const props = defineProps<Props>();

const route = useRoute();
const groupsData = ref({ visible: false, groups: [] });
const currentHash = ref('');

const hashChanged = computed(() => {
  return route.hash !== currentHash.value;
});

const toggleGroup = (groupIndex: number, newState: boolean) => {
  const selectedGroup = groupsData.value.groups[groupIndex];
  selectedGroup.questions = selectedGroup.questions.map((question) => ({
    ...question,
    config: {
      ...question.config,
      expanded: newState,
    },
  }));
};

const openQuestionFromHash = async (hash: string) => {
  const id = hash.replace('#', '');
  await nextTick();

  const element = document.getElementById(id);

  if (element) {
    const anchorIndex = element.getAttribute('data-anchor-index');

    if (anchorIndex) {
      const [groupIndex, questionIndex] = anchorIndex.split(',');
      groupsData.value.visible = true;
      groupsData.value.groups[parseInt(groupIndex)].questions[parseInt(questionIndex)].config.expanded = true;
    }
  }
};

const toggleQuestion = (groupIndex: number, questionIndex: number) => {
  const selectedQuestion = groupsData.value.groups[groupIndex].questions[questionIndex];
  selectedQuestion.config.expanded = !selectedQuestion.config.expanded;
};

const getShowAll = (group: FaqGroup) => {
  return !group.questions.every((question) => question.config?.expanded === true);
};

watch(
  () => route.hash,
  (hash) => {
    openQuestionFromHash(hash);
  },
);

groupsData.value.groups = props.groups.map((group: FaqGroup, groupIndex: number) => ({
  ...group,
  visible: !groupIndex,
  questions: group.questions.map((item) => ({
    ...item,
    config: {
      ...item.config,
      expanded: false,
    },
    id: item.config?.id,
  })),
}));

onMounted(() => {
  if (route.hash) {
    openQuestionFromHash(route.hash);
  }
});

onUpdated(() => {
  if (hashChanged.value) {
    currentHash.value = route.hash;
    openQuestionFromHash(route.hash);
  }
});
</script>

<template>
  <SlpSection :id="config.id" :background-color="config?.backgroundColor ? config?.backgroundColor : ''">
    <div class="slp-faq slp-mb-96">
      <div class="faq__title">
        <div v-if="config?.normalHeader" class="faq__title__normal">
          <SlpTypography tag="h2" variant="heading2-bold">
            <div v-html="$md.render(header)" />
          </SlpTypography>
        </div>
        <div v-else class="faq__title__sticky">
          <div>
            <div v-if="activeHeader" class="faq__title__active">{{ activeHeader }}</div>
            <SlpTypography tag="h2" variant="heading2-bold">
              <div v-html="$md.render(header)" />
            </SlpTypography>
          </div>
          <a
            v-if="config?.hasJumpDown"
            class="jump_button"
            :href="'#' + (groups.slice(-1)[0].config.id || toKebabCase(groups.slice(-1)[0].header))"
            data-ga-name="jump-down"
            data-ga-location="faq"
          >
            <SlpTypography tag="span" variant="body3"> {{ t('accordions.jumpDown') }} </SlpTypography>
            <SlpIcon :icon="ChevronLgRight" />
          </a>
        </div>
      </div>
      <div class="faq">
        <div
          v-for="(group, groupIndex) in groupsData.groups"
          :id="group.config.id"
          :key="group.header"
          data-section
          class="faq__container"
        >
          <div class="faq__wrapper">
            <div
              v-if="group.header || config.showToggle"
              aria-live="polite"
              class="faq__group-header"
              :class="{ 'faq__group-header--has-header': group.header }"
            >
              <SlpTypography v-if="group.header" tag="h3" variant="heading4" class="faq__header">
                {{ group.header }}
              </SlpTypography>
              <div />

              <button
                type="button"
                class="action"
                :data-toggle-group="group.config?.dataToggle || toKebabCase(group.header)"
                @click="toggleGroup(groupIndex, !group.questions.every((question) => question.config?.expanded))"
              >
                <SlpTypography
                  class="group-control"
                  variant="body2"
                  role="button"
                  :aria-label="
                    getShowAll(group)
                      ? `Expand all ${group.header ? ` ${group.header}` : ''} items`
                      : `Close all ${group.header ? ` ${group.header}` : ''} items`
                  "
                >
                  {{ getShowAll(group) ? t('accordions.showAll') : t('accordions.hideAll') }}
                </SlpTypography>
              </button>
            </div>
            <div
              v-for="(item, questionIndex) in group.questions"
              :id="item.config.id"
              :key="`question-${groupIndex}-${questionIndex}`"
              class="faq__question-wrapper"
              :data-anchor-index="`${groupIndex},${questionIndex}`"
            >
              <CommonAccordion
                :data="{
                  header: item.question,
                  config: {
                    id: item.config.id,
                    analytics: {
                      dataGaName: 'faq-accordion',
                      dataGaLocation: 'faq',
                      dataToggleGroup: group.header,
                    },
                  },
                }"
                :is-open="item.config.expanded"
                @toggle-controller="toggleQuestion(groupIndex, questionIndex)"
              >
                <template #content>
                  <div class="faq__answer">
                    <div v-html="$md.render(item.answer)" />
                    <router-link :to="{ hash: `#${item.config?.id}` }" append>
                      <SlpIcon class="anchor-icon" :icon="Anchor" color="black" />
                    </router-link>
                  </div>
                </template>
              </CommonAccordion>
            </div>
          </div>
        </div>
      </div>
    </div>
  </SlpSection>
</template>

<style lang="scss" scoped>
$visible-height: 70px;

.jump_button {
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
  height: 100%;
  width: 57px;
  background-color: $color-surface-900;
  color: $color-primary-200;
  border-radius: $border-radius-4;
  padding: $spacing-32 $spacing-8;
  margin-top: 25vh;
  text-align: center;
  &:hover {
    background-color: $color-surface-950;
  }
  .slp-icon {
    transform: rotate(90deg);
    stroke: none !important;
  }
  @media (max-width: $breakpoint-lg) {
    display: none;
  }
}

.slp-faq {
  display: flex;
  justify-content: space-between;
  padding: $spacing-96 $spacing-16 !important;
  flex-direction: column;
  @media (min-width: $breakpoint-lg) {
    flex-direction: row;
  }

  @media (max-width: $breakpoint-md) {
    padding: $spacing-64 $spacing-16 !important;
  }
}

.router-link-active .slp-icon {
  color: $color-text-300;
}

.anchor-target {
  bottom: 100%;
  display: block;
  height: 75px;
  position: absolute;
  visibility: hidden;
  width: 100%;
}

.faq {
  max-width: 100%;
  @media (min-width: $breakpoint-lg) {
    max-width: 60%;
    min-width: 60%;
  }

  &__title {
    padding-right: $spacing-48;
    margin-bottom: $spacing-32;
    text-align: left;
    position: relative;

    @media (max-width: $breakpoint-md) {
      margin: 0;
      padding: 0;
    }
    &__active {
      font-size: 1.3rem;
      margin-bottom: 1rem;
    }
    &__sticky {
      top: 200px;
      position: sticky;
      display: inline-block;
    }
    &__normal {
      position: relative;
      display: inline-block;
    }
  }

  .group-control {
    color: $color-text-link-100;
    cursor: pointer;
    text-decoration: underline;
    font-weight: 600;
    white-space: nowrap;
  }

  &__container {
    margin: 2rem 0;
  }

  &__wrapper {
    display: inline-block;
    width: 100%;

    .action {
      border: none;
    }
  }

  &__group-header {
    padding: $spacing-16 0;
    display: flex;
    background: transparent;
    justify-content: space-between;
    border-bottom: 1px solid $color-surface-300;
    align-items: center;
    position: relative;
    min-height: $visible-height;
    color: $color-primary-200;

    &--has-header {
      border-bottom: 1px solid $color-surface-500;
    }
  }

  &__header {
    font-size: 24px;
    line-height: 30px;
    @media (min-width: $breakpoint-lg) {
      font-size: 32px;
      line-height: 36px;
    }
  }

  &__question-wrapper {
    &:deep(.accordion) {
      .accordion__summary {
        padding: $spacing-16 0;
        min-height: $visible-height;
        border-bottom: 1px solid $color-surface-300;
        color: $color-primary-200;
        font-size: $text-heading-5;
        font-weight: 400;
        letter-spacing: $letter-spacing-heading-5;
        line-height: $line-height-heading-5;

        @media (max-width: $breakpoint-md) {
          font-size: $text-heading-5-mobile;
          line-height: $line-height-heading-5-mobile;
        }
      }

      .accordion__content-container {
        padding: $spacing-16 0 0;
      }

      .accordion__icon {
        margin-left: $spacing-16;
        width: 13px;
        height: 12px;
        &:before,
        &:after {
          background-color: $color-primary-200;
          height: 12px;
        }
      }
    }
  }

  &__answer {
    display: flex;
    justify-content: space-between;
    align-items: center;
    line-height: 24px;
    font-size: 16px;

    :deep(ul) {
      list-style-type: disc;
      list-style-position: inside;
    }

    :deep(ol) {
      list-style: initial;
      list-style-type: decimal;
      list-style-position: inside;
    }

    :deep(li) {
      margin-bottom: $spacing-8;
    }

    :deep(p:not(:last-of-type)),
    :deep(ul:not(:last-of-type)),
    :deep(ol:not(:last-of-type)),
    :deep(p:has(+ ul)),
    :deep(p:has(+ ol)),
    :deep(ul:has(+ ul)),
    :deep(ul:has(+ ol)),
    :deep(ol:has(+ ul)),
    :deep(ol:has(+ ol)) {
      margin-bottom: $spacing-16;
    }

    .anchor-icon {
      cursor: pointer;
      margin-left: $spacing-16;
    }
  }
}
</style>
